import java.applet.Applet;
import java.awt.Color;
import java.awt.Graphics;

public class ExamCounter extends Applet implements Runnable {

	private static final long serialVersionUID = 1L;
	
	//miliseconds to draw new time
	private int timeStep;
	private ExamClockwork ecw;
	private Thread counterThread;
	private boolean okToRun;
	
	//Methods to describe this applet
	public String getAppletInfo(){
		String msg = 
			"Author: Rocco Melzian, TU Berlin, 21.06.2005. \n\n Usage: \n" +
			"When applet used fot hte first time you have to set reset to true to init your max value, otherwise default value 90 minutes will be initialized!\n" +
			"<applet code=\"ExamCounter.class\" archive=\"ExamCounter.jar\" height=\"15\" width=\"150\">\n"+
            "<param name=\"reset\" value=\"true\" /> <!-- true || false -->\n" +
            "<param name=\"step\" value=\"1000\" /> <!-- milliseconds -->\n" +
            "<param name=\"max\" value=\"90\" /> <!-- minutes  ignored if reset=false -->\n" +
            "Countdown needs Java-plugin!\n" +
			"</applet>\n";
		return(msg);
	}
	
	public String[][] getParameterInfo(){
		String[][] msg = {
				{"max","int","e.g. 90; >0; how many minutes to count down"},
				{"step","int","e.g. 1000; >0; update intervall in milliseconds"},
				{"reset","boolean","e.g. true || false, reset counter when reloading this page?"},
		};
		return(msg);
	}
	
	//////////////////////////////////////////////
	public void init(){
		
		//get clockwork
		ecw=ExamClockwork.getExamClockwork();
		 
		//set background
		setBackground(Color.white);
		
		//set default timestep
		timeStep = 1000;
		
		//set runvariabel to true, setting this to false stops thread
		okToRun=true;

		//start thread
		counterThread = new Thread(this);
		counterThread.start();
 	}
	
	
	public void start(){
		//set timeStep-> to display e.g. every 1 seconds set parameter step to 1000
		//<param name="step" value="1000" />
	    timeStep = Integer.valueOf(getParameter("step")).intValue();
		
		//check wheter to start new counter
		if(getParameter("reset").equals("true"))
		{
			//set maximum minutes
			if(Integer.valueOf(getParameter("max")).intValue() > 0){
			    ecw.setMaxDelta(Integer.valueOf(getParameter("max")).longValue());
			}else{
			  System.out.println(getAppletInfo() + "\n Set max to 90 minutes");
			}
			
			//re-init clockwork
			ecw.init();
		}
	}
	
	public void run(){
        while(okToRun == true)
        {
        	repaint();
            try {
            	Thread.sleep(timeStep);
            } catch (InterruptedException e) {}
        }
	}
	
	public void paint(Graphics screen){
		screen.setColor(Color.white);
		screen.drawString(ecw.getString(),15,15);

		screen.setColor(ecw.getCurrentColour());
		screen.drawString(ecw.getString(1),15,15);
	}
}